
' Mehrfachauswahl (Multiple-Choice) mit VBScript

Dim bStart, choice, delim, input, ix, prompt

prompt = "Available options:" & vbNewLine & vbNewLine & _
        "1. Option 1" & vbNewLine & _
        "2. Option 2" & vbNewLine & _
        "3. Option 2" & vbNewLine & _
        "4. Option 2" & vbNewLine & _
        "5. Option 3" & vbNewLine & vbNewLine & _
        "Enter your selection (e.g. 1,3-5)."

input = Replace(InputBox(prompt, "Selection"), " ", "")

If Len(input) = 0 Then
    MsgBox "No choice was made."
    WScript.Quit
End If

If Not NumList(input, True) Then
    MsgBox "Incorrect input."
    WScript.Quit
End If

choice = Split(input, ",")
input = ""
bStart = True
For Each ix in choice
    delim = InStr(ix, "-")
    If delim Then
        Append input, GetRange(ix, delim)
    Else
        Append input, ix
    End If
Next

MsgBox input, , "Result"
If Len(input) Then
    Proc_Options input
Else
    MsgBox "No or invalid selection."
End If

WScript.Quit


Sub Proc_Options(sInp)
    Dim aInp, msg, opt
    aInp = Split(sInp, ",")
    For Each opt in aInp
        msg = msg & opt & vbNewLine
        Select Case opt
            Case 1
                msg = msg & "Performing option 1 procedure ..." & vbNewLine
            Case 2
                msg = msg & "Performing option 2 procedure ..." & vbNewLine
            Case 3
                msg = msg & "Performing option 3 procedure ..." & vbNewLine
            Case 4
                msg = msg & "Performing option 4 procedure ..." & vbNewLine
            Case 5
                msg = msg & "Performing option 5 procedure ..." & vbNewLine
        End Select
    Next
    if Len(msg) = 0 Then msg = "(none)"
    MsgBox msg, , "Selected Options"
End Sub


Sub Append(ByRef input, ByVal ix)
    ' shared bStart
    If Len(ix) = 0 Then Exit Sub
    If bStart Then
        input = ix
        bStart = False
    Else
        input = input & "," & ix
    End If
End Sub

Function GetRange(sRange, p)
    Dim i1, i2, n
    On Error Resume Next
    sRange = Replace(sRange, "-", "")
    If p > 1 Then
        i1 = CInt(Left(sRange, p - 1))
        i2 = CInt(Mid(sRange, p))
        If i2 > i1 Then
            GetRange = CStr(i1)
            For n = i1 + 1 To i2
                GetRange = GetRange & "," & CStr(n)
            Next
        Else
            GetRange = CStr(i2)
        End If
    Else
        GetRange = sRange
    End If
    If Err Then
        GetRange = ""
        Err.Clear
    End If
    On Error GoTo 0
End Function

Function NumList(sInp, bRange)
    Dim rex
    Set rex = New RegExp
    If bRange Then
        rex.Pattern = "[^ 0-9,-]"
    Else
        rex.Pattern = "[^ 0-9,]"
    End If
    If rex.Test(sInp) Then
        NumList = False
    Else
        NumList = True
    End If
End Function

